import cli_dnl
#cli_dnl.configuration.host='http://176.9.45.112/api_dnl/v1'
#cli_dnl.configuration.host='http://88.99.175.131/api_dnl/v1'
#cli_dnl.configuration.host='https://switchportal.call1800.org/api_dnl/v1'
#cli_dnl.configuration.host='http://localhost:8000/v1'
#cli_dnl.configuration.host='http://108.165.2.25:8001/v1'
#cli_dnl.configuration.host='http://151.80.37.10/api_dnl/v1'
from datetime import datetime,timedelta
from time import sleep
from pytz import UTC
import json

def logoff():
    cli_dnl.configuration.api_key['X-Auth-Token']=None

def auth(user_id=1,silent=False):
    from api_dnl.settings import JWT_SIGNATURE
    import jwt
    data = dict(user_id=user_id, expired=int((datetime.now(UTC) + timedelta(days=30)).timestamp()))
    cli_dnl.configuration.api_key['X-Auth-Token'] = jwt.encode(data, JWT_SIGNATURE, algorithm='HS256').decode('utf-8')
    if not silent:
        print(user_id,cli_dnl.configuration.api_key['X-Auth-Token'])
    return user_id

def auth_c(client_id):
    auth()
    api=cli_dnl.apis.AuthApi()
    r=api.auth_as_client_post(body={'client_id':client_id})
    cli_dnl.configuration.api_key['X-Auth-Token'] = r.payload.token
    print(client_id,r.payload.user.user_id, r.payload.user.name, r.payload.token)
    return r
    #print(r)

def auth_a(agent_id):
    auth()
    api=cli_dnl.AuthApi()
    r=api.auth_as_agent_post(body={'agent_id':agent_id})
    cli_dnl.configuration.api_key['X-Auth-Token'] = r.payload.token
    print(r.payload.user.user_id, r.payload.user.name, r.payload.token)
    return r
    #print(r)

def auth_random_c(**kwargs):
    auth()
    kwargs['status']=True
    mems = cli_dnl.CarrierApi().carrier_simple_list_get(**kwargs)
    items = mems.payload.items
    i=0
    random.shuffle(items)
    for m in items:
        try:
            r = cli_dnl.AuthApi().auth_as_client_post(body={'client_id': m.client_id})
            cli_dnl.configuration.api_key['X-Auth-Token'] = r.payload.token
            print(m.client_id, r.payload.token)
            return m
        except Exception as e:
            continue

def auth_random_a(**kwargs):
    auth()
    kwargs['status'] = True
    mems = cli_dnl.AgentApi().agent_list_get(**kwargs)
    items = mems.payload.items
    i=0
    random.shuffle(items)
    for m in items:
        try:
            #m=random.choice(items)
            r = cli_dnl.AuthApi().auth_as_agent_post(body={'agent_id': m.agent_id})
            cli_dnl.configuration.api_key['X-Auth-Token'] = r.payload.token
            print(m.agent_id,r.payload.token)
            return m
        except Exception as e:
            continue



import random 
def bla(l=24):
    #letters=[chr(i) for i in range(48,58)]+[chr(i) for i in range(65,91)]+
    letters=[chr(i) for i in range(97,123)]
    ret=''
    for c in range(0,l):
        ret=ret+random.choice(letters)
    return ret.capitalize()

def bla_bla(l):
    ret = bla(random.randint(1,5))
    for i in range(0,l):
        ret += bla(random.randint(1,10)).lower()
        if random.randint(0, 7) == 0:
            ret += bla(random.randint(2,7)).lower()+' '
        if (i % 7 )==0:
            ret += '. '+bla(random.randint(4,7))
        else:
            if  random.randint(0,14) == 0:
                ret +=', '
            else:
                ret +=' '
    return ret

def dig(l=12):
    letters=[chr(i) for i in range(48,58)]
    ret=''
    for c in range(0,l):
        ret=ret+random.choice(letters)
    return ret

def ip(check_dublicates=True):
    l=[]
    while True:
        for i in range(0,4):
            l.append(str(random.randint(0,255)))
        ip='.'.join(l)
        if check_dublicates:
            ret=cli_dnl.TrunkApi().trunk_ip_list_get(ip=ip)
            if len(ret.payload.items)==0:
                return ip
        else:
            return ip

def bla_mail(set=0):
    if set==1:
        #return 'mizdesino@gmail.com'
        return 'testuser@denovolab.com'
    if set==2:
        return 'novvvster@gmail.com'
    if set==3:
        return '_novvv@mail.ru'
    return (bla(5)+'.'+bla(4)+'@'+bla(5)+'.'+bla(4)+'.'+random.choice(['com','com','net','org','cc','us','eu'])).lower()

def bla_comp():
    return bla(random.randint(2,9))+' '+bla(random.randint(2,13))+' ' +random.choice(['inc.','ltd.','&K','broth'])

def lorem_ipsum():
    return bla(6)+' '+ bla(2)+' '+ bla(4)+', '+bla(6)+' '+ bla(2)+' '+ bla(5)+' '+ bla(4)+' '+ bla(7)+'. ' +""" Lorem ipsum
 dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.
 Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
 Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. 
 Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."""

def get_rand(t):
    value = None
    if t == 'str':
        value = bla()
    if t == 'bool':
        value = random.choice([False,True])
    if t == 'float':
        value = round(random.random()*100,2)
    if t == 'int':
        value = int(random.random()*256)
    if t == 'date':
         value = (datetime.now()+timedelta(int(random.random()*256))).date()
    if t == 'datetime':
         value = datetime.now()+timedelta(int(random.random()*256))
    if t == 'time':
        value = str((datetime.now()+timedelta(hours=random.randint(0,256))).time())[0:8]
    return value

def rand_user(**kwargs):
    ret = cli_dnl.AuthApi().user_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.user_id,it,ret.payload.items)

def rand_ticket(**kwargs):
    ret = cli_dnl.AuthApi().ticket_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_agent(**kwargs):
    ret = cli_dnl.AgentApi().agent_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.agent_id,it,ret.payload.items)

def rand_client(**kwargs):
    ret = cli_dnl.CarrierApi().carrier_simple_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.client_id,it,ret.payload.items)

def rand_cli(**kwargs):
    ret = cli_dnl.OriginationApi().did_client_list_get()
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.client_id,it,ret.payload.items)

def rand_vendor(**kwargs):
    ret = cli_dnl.OriginationApi().did_vendor_list_get()
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.client_id,it,ret.payload.items)

def rand_trunk(**kwargs):
    ret = cli_dnl.TrunkApi().trunk_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.trunk_id,it,ret.payload.items)

def rand_ip(**kwargs):
    ret = cli_dnl.TrunkApi().trunk_ip_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.resource_ip_id,it,ret.payload.items)

def rand_time_profile(**kwargs):
    ret = cli_dnl.ConfigApi().config_time_profile_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.time_profile_id,it,ret.payload.items)

def rand_payment_term(**kwargs):
    ret = cli_dnl.ConfigApi().config_payment_term_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.payment_term_id,it,ret.payload.items)

def rand_cdr_visibility(**kwargs):
    ret = cli_dnl.ConfigApi().config_cdr_visibility_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_currency(**kwargs):
    ret = cli_dnl.SwitchApi().switch_currency_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.currency_id,it,ret.payload.items)

def rand_code_deck(**kwargs):
    ret = cli_dnl.SwitchApi().switch_code_deck_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.code_deck_id,it,ret.payload.items)

def rand_rate_table(**kwargs):
    ret = cli_dnl.SwitchApi().switch_rate_table_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.rate_table_id,it,ret.payload.items)

def rand_switch(**kwargs):
    ret = cli_dnl.SwitchApi().switch_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.switch_id,it,ret.payload.items)

def rand_switch_profile(**kwargs):
    ret = cli_dnl.SwitchApi().switch_sip_host_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_trunk_group(**kwargs):
    ret = cli_dnl.TrunkApi().trunk_group_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.group_id,it,ret.payload.items)

def rand_carrier_group(**kwargs):
    ret = cli_dnl.CarrierApi().carrier_group_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.group_id,it,ret.payload.items)


def rand_route_plan(**kwargs):
    ret = cli_dnl.RouteApi().route_plan_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.route_plan_id,it,ret.payload.items)

def rand_static_route(**kwargs):
    ret = cli_dnl.RouteApi().route_static_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.static_route_id,it,ret.payload.items)

def rand_dynamic_route(**kwargs):
    ret = cli_dnl.RouteApi().route_dynamic_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.dynamic_route_id,it,ret.payload.items)

def rand_product(**kwargs):
    try:
        ret = cli_dnl.ProductApi().product_list_get(**kwargs)
        assert (ret.success and len(ret.payload.items))
        it = random.choice(ret.payload.items)
        return (it.id,it,ret.payload.items)
    except Exception as e:
        if 'permission' in str(e):
            ret = cli_dnl.ProductApi().product_public_get(**kwargs)
            assert (ret.success and len(ret.payload.items))
            it = random.choice(ret.payload.items)
            return (it.id, it, ret.payload.items)
        else:
            raise e

def rand_mail_sender(**kwargs):
    ret = cli_dnl.ConfigApi().config_mail_sender_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_send_rate_template(**kwargs):
    ret = cli_dnl.ConfigApi().config_send_rate_template_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_billing_rule(**kwargs):
    ret = cli_dnl.OriginationApi().did_billing_rule_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)


def rand_rate_generation(**kwargs):
    ret = cli_dnl.ToolApi().tool_rate_generation_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_rate_generation_history(**kwargs):
    ret = cli_dnl.LogApi().log_rate_generation_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_rerate(**kwargs):
    ret = cli_dnl.ToolApi().tool_rerate_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_system_function(**kwargs):
    ret = cli_dnl.ConfigApi().config_system_function_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.system_function_id,it,ret.payload.items)

def rand_role(**kwargs):
    ret = cli_dnl.ConfigApi().config_role_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.role_id,it,ret.payload.items)

def rand_ftp(**kwargs):
    ret = cli_dnl.ConfigApi().config_ftp_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_import(**kwargs):
    ret = cli_dnl.LogApi().log_import_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)

def rand_png(**kwargs):
    kwargs['obj']='png'
    return rand_import(**kwargs)

def rand_invoice(**kwargs):
    ret = cli_dnl.FinanceApi().finance_invoice_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.invoice_id,it,ret.payload.items)

def rand_carrier_template(**kwargs):
    ret = cli_dnl.ConfigApi().config_carrier_template_list_get(**kwargs)
    assert (ret.success and len(ret.payload.items))
    it = random.choice(ret.payload.items)
    return (it.id,it,ret.payload.items)